'use strict';

var fs = require('fs');
var os = require('os');
var _ = require('underscore');
var glob = require('glob');

var root = fis.project.getProjectPath();
var path = require('path');


var defaultAutoImport = {
    'fis-common': ['widget/ui/components/mixin/*']
};


module.exports = function(content, file, conf){
    var autoImport = defaultAutoImport;
    var currentFilePath = file.origin;

    var setting = fis.config.get('settings.parser.less-common');
    if(setting && setting.autoImport){
        autoImport = setting.autoImport;
    }


    var autoImportsMatches = [];

    Object.keys(autoImport).forEach(function(item, idx){

        var val = autoImport[item];
        if(!_.isArray(val)){
            val = [item];
        }

        val.forEach(function(matchItem){
            autoImportsMatches.push(resolveImportPath(item, matchItem));
        });

    });

    var files =
        autoImportsMatches
            .reduce(function(left, current){
                return left.concat(glob.sync(current));
            }, [])
            .filter(function(item){
                return /\.less$/.test(item)
            })
            .map(function(item){
                return '@import "' + path.relative(path.dirname(currentFilePath), item) + '";';
            });

    return files.join(os.EOL) + content;
};

function resolveImportPath( moduleName, lessPath ){
    return path.resolve( root, '../' + moduleName, lessPath );
}